<html><head><!-- File generated by "simple-zope-website" by Ernesto Posse (c) 2002 --><title>aperiot</title> 
   
   
     
    <link rel="stylesheet" type="text/css" href="atglance.dtml_files/msdl.css"></head><body bgcolor="#ffffff"> 
    <!-- Title --> 
    <table summary="Table for page banner" border="0" cellpadding="0" cellspacing="0" height="94" width="100%"> 
      <tbody><tr> 
        <td width="214"> 
          <img src="atglance.dtml_files/mcgill.gif" align="left" border="0"> 
        </td> 
        <td align="right" valign="middle" width="100%"> 
          <h1>aperiot<br><hr noshade="noshade" width="460"></h1> 
        </td> 
      </tr> 
    </tbody></table> 

    <!-- Main frame --> 
    <table summary="Table for navigation bar, content and footer" border="0" cellpadding="5" cellspacing="0"> 
      <tbody><tr> 
        <td align="left" bgcolor="#cccccc" valign="top" width="109"> 


          <!-- Navigation bar --> 
          <table border="0" cellpadding="4" cellspacing="0" width="109"> 
            <tbody><tr> 
              <td width="11"> 
                <img src="atglance.dtml_files/red_dot.gif" valign="middle" align="middle" border="0"></td> 
              <td width="90"> 
                <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/index_html"><font color="black">Welcome</font></a></td> 
            </tr> 
            <tr> 
              <td width="11"> 
                <img src="atglance.dtml_files/red_dot.gif" valign="middle" align="middle" border="0"></td> 
              <td width="90"> 
                <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/atglance.dtml"><font color="black">Aperiot at glance</font></a></td> 
            </tr> 
            <tr> 
              <td width="11"> 
                <img src="atglance.dtml_files/red_dot.gif" valign="middle" align="middle" border="0"></td> 
              <td width="90"> 
                <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/distro.dtml"><font color="black">Distribution</font></a></td> 
            </tr> 
            <tr> 
              <td width="11"> 
                <img src="atglance.dtml_files/red_dot.gif" valign="middle" align="middle" border="0"></td> 
              <td width="90"> 
                <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/doc.dtml"><font color="black">Documentation</font></a></td> 
            </tr> 
            <tr> 
              <td width="11"> 
                <img src="atglance.dtml_files/red_dot.gif" valign="middle" align="middle" border="0"></td> 
              <td width="90"> 
                <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/credits.dtml"><font color="black">Credits</font></a></td> 
            </tr> 
        </tbody></table> 

        </td><td align="left" valign="top"> 
          <!-- Contents --> 


          <p>

          </p><h2><font face="helvetica">aperiot</font>&nbsp;at glance</h2>

          <p>
          <font face="helvetica">aperiot</font>&nbsp;is both a grammar description language and a parser generator
          for Python. Its purpose is to provide the means to describe a language's
          grammar and automatically generate a parser to recognize and process
          text written in that language.<a href="#tthFtNtAAB" name="tthFrefAAB"><sup>1</sup></a> It is intended to be used mainly for programming and modelling languages.

          </p><p>
          The basic idea is this:

          </p><p>

          </p><ol type="1"><p>
          </p><li> Write the grammar of a language you want to parse using the <font face="helvetica">aperiot</font>&nbsp;meta-language
          described in the <a href="http://moncs.cs.mcgill.ca/people/eposse/projects/aperiot/doc.dtml">documentation</a>. Save this in a plain
          text file with a <tt>.apr</tt> extension.</li>
          <p>
          </p><li> Use the <font face="helvetica">aperiot</font>&nbsp;grammar compiler script to produce one of two possible
          grammar representations.</li>
          <p>
          </p><li> In your application, load one of the generated representations using
          a simple API provided in <font face="helvetica">aperiot</font>, which results in a Python object,
          the parser, that can parse strings or files given as input.</li>
          </ol>
          To illustrate this process, we'll consider a simple language for arithmetic
          expressions. The application is a simple calculator.

          <p>

          </p><ol type="1"><p>
          </p><li> Write the grammar below in a plain text file named <tt>aexpr.apr</tt>. 

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <font color="#00ff00">#&nbsp;This&nbsp;is&nbsp;a&nbsp;simple&nbsp;language&nbsp;for&nbsp;arithmetic&nbsp;expressions</font>

          </tt><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          <b><font color="#0000ff">numbers</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;number

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          <b><font color="#0000ff">operators</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;plus&nbsp;&nbsp;&nbsp;<font color="#ff00ff">"+"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;times&nbsp;&nbsp;<font color="#ff00ff">"*"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;minus&nbsp;&nbsp;<font color="#ff00ff">"-"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;div&nbsp;&nbsp;&nbsp;&nbsp;<font color="#ff00ff">"/"</font>

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          <b><font color="#0000ff">brackets</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;lpar&nbsp;&nbsp;<font color="#ff00ff">"("</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;rpar&nbsp;&nbsp;<font color="#ff00ff">")"</font>

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          <b><font color="#0000ff">start</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;EXPR

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          <b><font color="#0000ff">rules</font></b>

          </tt></p><p>
<tt>          EXPR&nbsp;-&gt;&nbsp;TERM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;TERM&nbsp;plus&nbsp;EXPR&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1&nbsp;+&nbsp;$3"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;TERM&nbsp;minus&nbsp;EXPR&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1&nbsp;-&nbsp;$3"</font>

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>
TERM&nbsp;-&gt;&nbsp;FACTOR&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;FACTOR&nbsp;times&nbsp;TERM&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1&nbsp;*&nbsp;$3"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;FACTOR&nbsp;div&nbsp;TERM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$1&nbsp;/&nbsp;$3"</font>

          </tt></p><p>
<tt>          &nbsp;

          </tt></p><p>
<tt>          FACTOR&nbsp;-&gt;&nbsp;number&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"float($1)"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;minus&nbsp;FACTOR&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"-$2"</font>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;lpar&nbsp;EXPR&nbsp;rpar&nbsp;&nbsp;:&nbsp;<font color="#ff00ff">"$2"</font>
          </tt>
          </p></dd></dl>
          In this file, the sections titled ``numbers,'' ``operators,''
          and ``brackets'' define symbolic names for the input tokens. The
          last section provides the actual rules. Each rule is annotated with
          a ``Python expression template.'' This is, a Python expression
          that uses <em>placeholders</em> (numbers preceded by `$'.) The placeholders
          refer to the corresponding symbol in the symbol sequence. For example,
          in <tt>FACTOR times TERM : "$1 * $3"</tt>, <tt>$1</tt>
          refers to <tt>FACTOR</tt>, and <tt>$3</tt> refers to <tt>TERM</tt>.
          When parsing, if this rule is applied, the result of applying the
          actions that yield a <tt>FACTOR</tt> will replace the <tt>$1</tt>
          entry and the result of applying the actions that yield <tt>TERM</tt>
          will replace the entry <tt>$3</tt>, and the result of evaluating
          the full Python expression will be the result of applying this rule.</li>
          <p>
          </p><li> Use the <font face="helvetica">aperiot</font>&nbsp;grammar compiler script to produce one of two possible
          grammar representations.

          <p>
          In the comand-line prompt, execute the grammar compiler by typing:

          </p><p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          apr&nbsp;aexpr.apr
          </tt></dd>
          </dl>
          This will generate a Python package called <tt>aexpr_cfg</tt> in
          the same directory where <tt>aexpr.apr</tt> is located. This package
          contains a module called <tt>aexpr.py</tt>.</li>
          <p>
          </p><li> In your application, load one of the generated representations using
          a simple API provided in <font face="helvetica">aperiot</font>, which results in a Python object,
          the parser, that can parse strings or files given as input. 

          <p>
          Assuming that the <font face="helvetica">aperiot</font>&nbsp;package and the directory where you generated
          <tt>aexpr_cfg</tt> are in the Python path, in your application you
          can write something like this:

          </p><p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;build_parser

          </tt><p>
<tt>          myparser&nbsp;=&nbsp;build_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;<font color="#ff00ff">"56&nbsp;+43*&nbsp;-21/(12-7)"</font>

          </tt></p><p>
<tt>          outcome&nbsp;=&nbsp;myparser.parse(text_to_parse)

          </tt></p><p>
<tt>          <b><font color="#0000ff">print</font></b>&nbsp;outcome
          </tt>
          </p></dd></dl>
          Alternatively, you can split the parsing process in two steps: 1)
          obtaining the parse tree, and 2) applying the rule actions on the
          parse tree:

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;build_parser

          </tt><p>
<tt>          myparser&nbsp;=&nbsp;build_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;<font color="#ff00ff">"56&nbsp;+43*&nbsp;-21/(12-7)"</font>

          </tt></p><p>
<tt>          tree&nbsp;=&nbsp;myparser.parse(text_to_parse,&nbsp;apply_actions=False)

          </tt></p><p>
<tt>          outcome&nbsp;=&nbsp;myparser.apply_actions(tree)

          </tt></p><p>
<tt>          <b><font color="#0000ff">print</font></b>&nbsp;outcome
          </tt>
          </p></dd></dl>
          Furthermore, the input provided to the parser could be a file:

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;build_parser

          </tt><p>
<tt>          myparser&nbsp;=&nbsp;build_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;file(<font color="#ff00ff">"myfile.txt"</font>,&nbsp;<font color="#ff00ff">`r'</font>)

          </tt></p><p>
<tt>          outcome&nbsp;=&nbsp;myparser.parse(text_to_parse)

          </tt></p><p>
<tt>          text_to_parse.close()

          </tt></p><p>
<tt>          <b><font color="#0000ff">print</font></b>&nbsp;outcome
          </tt>
          </p></dd></dl></li>
          </ol>
          The scheme described above generates a minimal Python representation
          of the grammar in the <tt>aexpr.py</tt> module within the <tt>aexpr_cfg</tt>
          package, and the parser object is built at run-time in the client
          application by the <tt>build_parser</tt> function. This approach,
          however, may be time-consuming if the language's grammar is large.
          <font face="helvetica">aperiot</font>&nbsp;provides alternative approach, in which the parser object
          is built during the grammar compilation and saved into a special file
          (with a <tt>.pkl</tt> extension,) which then can be quickly loaded
          by the application. To do this, use the <tt>-f</tt> command-line option
          of the <tt>apr</tt> script:

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          apr&nbsp;-f&nbsp;aexpr.apr
          </tt></dd>
          </dl>
          This will generate other files in the <tt>aexpr_cfg</tt> package,
          in particular a file called <tt>aexpr.pkl</tt>, containing the parser
          object itself.

          <p>
          Then, in the client Python application, use the <tt>load_parser</tt>
          function instead of the <tt>build_parser</tt> function:

          </p><p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;load_parser

          </tt><p>
<tt>          myparser&nbsp;=&nbsp;load_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;file(<font color="#ff00ff">"myfile.txt"</font>,&nbsp;<font color="#ff00ff">`r'</font>)

          </tt></p><p>
<tt>          outcome&nbsp;=&nbsp;myparser.parse(text_to_parse)

          </tt></p><p>
<tt>          text_to_parse.close()

          </tt></p><p>
<tt>          <b><font color="#0000ff">print</font></b>&nbsp;outcome
          </tt>
          </p></dd></dl>
          Usually you want to report parsing errors in a user-friendly way.
          To do that, wrap around the parse method invocation with an exception
          handler as follows:

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;load_parser

          </tt><p>
<tt>          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.llparser&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;ParsingException

          </tt></p><p>
<tt>          myparser&nbsp;=&nbsp;load_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;file(<font color="#ff00ff">"myfile.txt"</font>,&nbsp;<font color="#ff00ff">`r'</font>)

          </tt></p><p>
<tt>          <b><font color="#0000ff">try:</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;outcome&nbsp;=&nbsp;myparser.parse(text_to_parse)

          </tt></p><p>
<tt>          &nbsp;<b><font color="#0000ff">&nbsp;&nbsp;&nbsp;print</font></b>&nbsp;outcome

          </tt></p><p>
<tt>          <b><font color="#0000ff">except</font></b>&nbsp;ParsingException,&nbsp;e:

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;<b><font color="#0000ff">print</font></b>&nbsp;e

          </tt></p><p>
<tt>          text_to_parse.close()

          </tt></p><p>
<tt>          </tt>
          </p></dd></dl>The printout of the parsing error can be made nicer by keeping a separate
          copy of the source file:

          <p>

          </p><dl compact="compact">
           <dt><b></b></dt>
          	<dd>
           <tt>
          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.parsergen&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;load_parser

          </tt><p>
<tt>          <b><font color="#0000ff">from</font></b>&nbsp;aperiot.llparser&nbsp;<b><font color="#0000ff">import</font></b>&nbsp;ParsingException

          </tt></p><p>
<tt>          myparser&nbsp;=&nbsp;load_parser(<font color="#ff00ff">`aexpr'</font>)

          </tt></p><p>
<tt>          <font color="#000000">text&nbsp;=&nbsp;file(</font><font color="#ff00ff">"myfile.txt"</font><font color="#000000">,</font>&nbsp;<font color="#ff00ff">`r'</font><font color="#000000">)</font>

          </tt></p><p>
<tt>          <font color="#000000">lines&nbsp;=&nbsp;text.readlines()</font>

          </tt></p><p>
<tt>          <font color="#000000">text.close()</font>

          </tt></p><p>
<tt>          text_to_parse&nbsp;=&nbsp;file(<font color="#ff00ff">"myfile.txt"</font>,&nbsp;<font color="#ff00ff">`r'</font>)

          </tt></p><p>
<tt>          <b><font color="#0000ff">try:</font></b>

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;outcome&nbsp;=&nbsp;myparser.parse(text_to_parse)

          </tt></p><p>
<tt>          &nbsp;<b><font color="#0000ff">&nbsp;&nbsp;&nbsp;print</font></b>&nbsp;outcome

          </tt></p><p>
<tt>          <b><font color="#0000ff">except</font></b>&nbsp;ParsingException,&nbsp;e:

          </tt></p><p>
<tt>          &nbsp;&nbsp;&nbsp;&nbsp;e.pprint(lines[e.linenum-1])

          </tt></p><p>
<tt>          text_to_parse.close()

          </tt></p><p>
<tt>          </tt>
          </p></dd></dl><hr><h3>Footnotes:</h3>

          <p>
          <a name="tthFtNtAAB"></a><a href="#tthFrefAAB"><sup>1</sup></a>``Aperio'' is a Latin word meaning ``to uncover,'' ``to
          unearth.'' A parser is, after all, a tool that uncovers the structure
          of text. 

        </p></td> 
      </tr> 
    </tbody></table> 
   


</body></html>